void LandRushCreator::SetOre()
{
	if(!initiated)
		return;
	if((landUnit1.IsLive()) && (landUnit1.GetType() == mapCargoTruck) && (landUnit1.OwnerID() == LCp))
		landUnit1.SetTruckCargo(truckCommonMetal, 1000);
}

void LandRushCreator::SetFood()
{
	if(!initiated)
		return;
	if((landUnit1.IsLive()) && (landUnit1.GetType() == mapCargoTruck) && (landUnit1.OwnerID() == LCp))
		landUnit1.SetTruckCargo(truckFood, 1000);
}

void LandRushCreator::Init(int x, int y, int p)
{
	LCmirX = TethysGame::GetRand(2);
	LCmirY = TethysGame::GetRand(2);
	LCmirX = (LCmirX == 1)? 1:-1;
	LCmirY = (LCmirY == 1)? 1:-1;

	if(LCmirX == 1)
		if(LCmirY == 1)
			LCrot = 5;
		else
			LCrot = 3;
	else
		if(LCmirY == 1)
			LCrot = 7;
		else
			LCrot = 1;
	LCx = x; LCy = y; LCp = p;
	initiated = true;
}

int LandRushCreator::CreateRush(map_id type, int xOff, int yOff, map_id load)
{
	if(!initiated)
		return -1;

	bool isTank = false;
	if((type == mapLynx) || (type == mapPanther) || (type == mapTiger))
		isTank = true;
	int saveInt;
	saveInt = TethysGame::CreateUnit(landUnit1, type, LOCATION(LCx+LCmirX*xOff, LCy+LCmirY*yOff), LCp, load, (isTank)?0:LCrot);
	landUnit1.DoSetLights(1);
	return saveInt;
}

int LandRushCreator::CreateRush(map_id type, int xOff, int yOff)
{
	return CreateRush(type, xOff, yOff, mapNone);
}

// Setups up default land rush resources for all players
void LandRushCreator::SetupLandRushResources()
{

	if(!initiated)
		return;

    _Player &player = Player[LCp];

	switch(player.Difficulty())
	{
	case 0:		// Easy
		player.SetFoodStored(5000);
		player.SetWorkers(30);
		player.SetScientists(16);
		player.SetKids(24);
		player.MarkResearchComplete(3401);
		player.MarkResearchComplete(3303);
		player.MarkResearchComplete(3304);
		player.MarkResearchComplete(3305);

		break;
	case 1:		// Normal
		player.SetFoodStored(3400);
		player.SetWorkers(26);
		player.SetScientists(13);
		player.SetKids(21);
		player.MarkResearchComplete(3303);
		player.MarkResearchComplete(3304);
		player.MarkResearchComplete(3305);
		break;
	case 2:		// Hard
		player.SetFoodStored(1800);
		player.SetWorkers(22);
		player.SetScientists(10);
		player.SetKids(22);
		player.MarkResearchComplete(3303);
	}
} // end SetupLandRushResources

// Create player objects
void LandRushCreator::CreateFullLandRush(int s, int xPos, int yPos)
{
	Init(xPos, yPos, s);
	// Center view on start location
	Player[s].CenterViewOn(xPos, yPos);
	if(!customRes)
		SetupLandRushResources();
	int easy = 0;

	CreateRush(mapRoboSurveyor, -3, -3);
	CreateRush(mapConVec, -2, -2, mapCommandCenter);
	CreateRush(mapConVec, 0, -2, mapTokamak);
	CreateRush(mapConVec, 1, -1, mapStructureFactory);
	CreateRush(mapConVec, -2, 0, mapCommonOreSmelter);
	CreateRush(mapConVec, -1, 1, mapAgridome);
	if(Player[s].Difficulty() == 0)
	{
		CreateRush(mapConVec, 0, 2, mapStandardLab);
		CreateRush(mapConVec, 2, 0, mapVehicleFactory);
		easy++;
	}
	CreateRush(mapCargoTruck, 0+easy, 2+easy);
	SetOre();
	CreateRush(mapCargoTruck, 2+easy, 0+easy);
	SetOre();
	CreateRush(mapCargoTruck, 2+easy, 2+easy);
	SetFood();
	CreateRush(mapEarthworker, 2+easy, 4+easy);
	CreateRush(mapRoboMiner, 4+easy, 2+easy);

	map_id startWeapon = (Player[s].IsEden())?mapLaser:mapMicrowave;

	Location fightUnits[] = {
		{-5, 0},
		{-4, 0},
		{-3, 0},
		{-5, 1},
		{-4, 1},
		{-3, 1},
		{3, -1},
		{4, -1},
		{5, -1},
		{3, 0},
		{4, 0},
		{5, 0}
	};

	for(int v = 0; v<TethysGame::InitialUnits();v++)
	{
		CreateRush(mapLynx, fightUnits[v].x, fightUnits[v].y, startWeapon);
	}
} // end SetupPlayerLandRush